Package org.zkoss.bind

## Enum Phase

- java.lang.Object
- - java.lang.Enum<Phase>
  - - org.zkoss.bind.Phase

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Comparable<Phase>`

      public enum Phase
      extends java.lang.Enum<Phase>

  The Phase of PhaseListener when doing binding. There are currently seven phases that executed in that order:
  Command :
  - `COMMAND`: do a command
  - `VALIDATE`: do validate before a command or zk event
  - `SAVE_BEFORE`: do save bindings before executing a command
  - `LOAD_BEFORE`: do load bindings before executing a command
  - `EXECUTE`: execute a command
  - `SAVE_AFTER`: do save bindings after executing a command
  - `LOAD_AFTER`: do load bindings after executing a command
  - `SAVE_BINDING`: do a save binding
  - `LOAD_BINDING`: do a load binding
  Global Command :
  - `GLOBAL_COMMAND`: do a global command
  - `EXECUTE`: execute a command
  Since:
    6.0.0
  Author:
    dennis

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `COMMAND` | command phase.
    `EXECUTE` | command execution phase.
    `GLOBAL_COMMAND` | global command phase.
    `INITIAL_BINDING` | initial binding phase
    `LOAD_AFTER` | load after command phase.
    `LOAD_BEFORE` | load before command phase.
    `LOAD_BINDING` | load binding phase.
    `SAVE_AFTER` | save after command phase.
    `SAVE_BEFORE` | save before command phase.
    `SAVE_BINDING` | save binding phase.
    `VALIDATE` | validate phase.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static Phase` | `valueOf​(java.lang.String name)` | Returns the enum constant of this type with the specified name.
    `static Phase[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### COMMAND

          public static final Phase COMMAND

      command phase.

    - #### GLOBAL_COMMAND

          public static final Phase GLOBAL_COMMAND

      global command phase.

    - #### VALIDATE

          public static final Phase VALIDATE

      validate phase.

    - #### SAVE_BEFORE

          public static final Phase SAVE_BEFORE

      save before command phase.

    - #### LOAD_BEFORE

          public static final Phase LOAD_BEFORE

      load before command phase.

    - #### EXECUTE

          public static final Phase EXECUTE

      command execution phase.

    - #### SAVE_AFTER

          public static final Phase SAVE_AFTER

      save after command phase.

    - #### LOAD_AFTER

          public static final Phase LOAD_AFTER

      load after command phase.

    - #### SAVE_BINDING

          public static final Phase SAVE_BINDING

      save binding phase.

    - #### LOAD_BINDING

          public static final Phase LOAD_BINDING

      load binding phase.

    - #### INITIAL_BINDING

          public static final Phase INITIAL_BINDING

      initial binding phase
      Since:
        8.0.0

  - ### Method Detail

    - #### values

          public static Phase[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (Phase c : Phase.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static Phase valueOf​(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null